/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package oniKeyEditor;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;


/**
 *
 * @author home
 */
public class inputOutput {

    static void readKeyFile(String dir) {
        String read="";
        String[] aux;

             BufferedReader fin=null;
            try { fin = new BufferedReader(new FileReader(dir + "key_config.txt"));
            } catch (FileNotFoundException ex) {
                dialogs.errorDialog("File key_config.txt not found. A new file will be created."
                    , "Error");
                    keyConversion.setDefaultKeys(); writeCleanFile(dir); return;
            }

            while (read!=null){ //while don't reach the end
                try {
                    
                    read = fin.readLine();

                    if (read==null){
                        char cDefault=main.getConfDefault();
                        if (cDefault!='0'){
                            String[] names=main.getConfNames();
                            main.jTextConfName.setText(names[Character.digit(cDefault-1, 10)]);
                        }
                        break;
                    }

                    if (read.startsWith("#Configurations:")){ //Read configurations names if exist
                        String[] names=read.split(",");
                        String[] naux=names[0].split("#Configurations:");
                        names[0]=naux[1];
                        main.setConfNames(names);
                        continue;
                    }

                    if (read.startsWith("#ConfDefault:")){ //Which is default configuration?
                        String[] names=read.split(":");
                        char[] daux=names[1].toCharArray();
                        main.setConfDefault(daux[0]);
                        main.setCurrentConf(daux[0]);
                        continue;
                    }

                    if (read.startsWith("#") || read.equals("unbindall")
                        || read.equals("") || read.equals(" ")) continue;
                    
                    aux = read.split("bind ");

                    try{
                    read = aux[1];
                    } catch( ArrayIndexOutOfBoundsException e )
                    {
                        dialogs.errorDialog("A problem occurred while reading 'key_config.txt'" +
                                ", please check it manually."
                    , "Error");
                        return;
                    }
                    aux=read.split(" to ");
                    
                    String key=aux[0]; String gameAction=aux[1];
                    keyConversion.convertFromBsl(key, gameAction);
                    
                } catch (IOException ex) {
                    dialogs.errorDialog("I/O error (key_config.txt) (modified file?)"
                    , "Error");
                }
            }

        try {
            fin.close();
        } catch (IOException ex) {
             dialogs.errorDialog("I/O error (key_config.txt) (modified file?)"
                    , "Error");
        }

    }

    static void ReadConf(char confNumber){

        if (main.getConfDefault()=='0') writeCleanFile(main.getCurrentDir()); //If we are using a custom file we should first make it oke standart

        main.setCurrentConf(confNumber);
        String[] names=main.getConfNames();
        main.jTextConfName.setText(names[Character.digit(confNumber-1, 10)]); //this weird code is to convert char in int and also subtract 1 to the number (array begins [0])

        String dir;

        dir=main.getCurrentDir();

        String read="";
        String[] aux;

             BufferedReader fin=null;
            try { fin = new BufferedReader(new FileReader(dir + "key_config.txt")); } catch (FileNotFoundException ex) {}

            while (read!=null){ //while don't reach the end
                try {

                    read = fin.readLine();

                    if (read==null)  dialogs.errorDialog("Conf not created yet."
                    , "Error");

                    if (read.startsWith("#Configuration "+confNumber)
                       || read.startsWith("##Configuration "+confNumber)){ //Read configurations names if exist

                        confNumber++; //For next confNumber check *

                        while (read!=null){

                             read = fin.readLine();

                             if (read==null || read.startsWith("#Configuration "+confNumber)
                                 || read.startsWith("##Configuration "+confNumber)){//*
                                 try {
                                    fin.close();
                                    } catch (IOException ex) {
                                        dialogs.errorDialog("Couldn't close I/O error (key_config.txt) (modified file?)", "Error");
                                    }
                                 break;
                             }

                         if (!read.startsWith("#bind") && !read.startsWith("bind")
                             || read.startsWith("#bind mousex") ||
                             read.startsWith("#bind mousey")) continue;

                            if (read.startsWith("#bind"))
                                 aux = read.split("#bind ");
                            else
                                 aux = read.split("bind ");

                            read = aux[1];

                            aux=read.split(" to ");

                            String key=aux[0]; String gameAction=aux[1];
                            keyConversion.convertFromBsl(key, gameAction);

                        }
                         try {
                            fin.close();
                            } catch (IOException ex) {
                                dialogs.errorDialog("Couldn't close I/O error (key_config.txt) (modified file?)"
                                 , "Error");
                            }
                        return;
                    }

                } catch (IOException ex) {
                    dialogs.errorDialog("I/O error (key_config.txt) (modified file?)"
                    , "Error");
                }

                }

    }

    static void writeKeyFile(String dir){

        if (main.getConfDefault()=='0'){ //If it's the first time that we are saving a custom file lets make it oke standart
            writeCleanFile(dir);
            return;
        }

        char current=main.getCurrentConf();

        String[] bufferBefore=ReadBeforeConf(current);
        String[] bufferAfter=ReadAfterConf(current);

        String[] boxContent = keyConversion.convertToArray();

        try {
            BufferedWriter fin = new BufferedWriter(new FileWriter(dir + "key_config.txt"));
            fin.write("#Generated with Oni Key Editor v1.0");fin.newLine();fin.newLine();
            fin.write("#Configurations:");

            String[] names=main.getConfNames();

            names[Character.digit(current-1, 10)]=main.jTextConfName.getText();
            main.setConfNames(names);

            /* ^ super weird code :S, this will get the name of the current conf
              And save it in the names array, the position is determined by
              current conf number, Character.digit is to convert from char to int*/
            
            for (int i=0; i<names.length; i++){
                fin.write(names[i]);
                if (i!=names.length-1)
                fin.write(",");
            }
            fin.newLine();

            fin.write("#ConfDefault:"+main.getConfDefault()); fin.newLine();fin.newLine();
            fin.write("unbindall"); fin.newLine();fin.newLine();

            if (current=='1'){

                for (int i=0; i<boxContent.length; i++){ //write actual conf
                   if (boxContent[i].endsWith("Keys")||boxContent[i].endsWith("Axis")) fin.newLine();

                    fin.write(boxContent[i]); fin.newLine();

                    if (i==boxContent.length-1) fin.newLine();
                }

                for (int i=0; i<bufferAfter.length; i++){ //write other confs
                    if (main.getConfDefault()==current){
                        bufferAfter[i]=Comment(bufferAfter[i]);
                    }
                    
                    fin.write(bufferAfter[i]); fin.newLine();
                }

                fin.close(); return;

            }
            else if(current=='5'){

                for (int i=0; i<bufferBefore.length; i++){ //write other confs
                    if (main.getConfDefault()==current){
                        bufferBefore[i]=Comment(bufferBefore[i]);
                    }

                    fin.write(bufferBefore[i]); fin.newLine();
                }

                for (int i=0; i<boxContent.length; i++){ //write actual conf
                     if (boxContent[i].endsWith("Keys")||boxContent[i].endsWith("Axis")) fin.newLine();

                    fin.write(boxContent[i]); fin.newLine();

                    if (i==boxContent.length-1) fin.newLine();
                }

                fin.close();
                return;
            }
            else{

              boolean Afound=false;
               
                for (int i=0; i<bufferBefore.length; i++){ //write other confs
                     if (main.getConfDefault()==current){
                        bufferBefore[i]=Comment(bufferBefore[i]);
                        Afound=true;
                    }
                    fin.write(bufferBefore[i]); fin.newLine();
                }

                for (int i=0; i<boxContent.length; i++){ //write actual conf
                    if (boxContent[i].endsWith("Keys")||boxContent[i].endsWith("Axis")) fin.newLine();

                    fin.write(boxContent[i]); fin.newLine();
                    
                    if (i==boxContent.length-1) fin.newLine();
                }

                for (int i=0; i<bufferAfter.length; i++){ //write other confs
                     if (main.getConfDefault()==current && Afound==false){
                        bufferAfter[i]=Comment(bufferAfter[i]);
                     }
                    fin.write(bufferAfter[i]); fin.newLine();
                }

                fin.close(); return;
            
            }
        } catch (IOException ex) {
            dialogs.errorDialog("Problem writting key_config.txt.", "Error");
        }
    }

     static void writeCleanFile(String dir){

        main.setCurrentConf('1');
        main.setConfDefault('1');
        
        String[] names = new String[5];

        for (int i=1; i<=names.length; i++) names[i-1]="NoNameYet "+i;
        main.setConfNames(names);

        names[0]=main.jTextConfName.getText();
        main.setConfNames(names);

        String[] boxContent = keyConversion.convertToArray();

        try {
            BufferedWriter fin = new BufferedWriter(new FileWriter(dir + "key_config.txt"));
            fin.write("#Generated with Oni Key Editor v1.0");fin.newLine();fin.newLine();

            fin.write("#Configurations:"+names[0]+",NoNameYet 2,NoNameYet 3,NoNameYet 4,NoNameYet 5");fin.newLine();

            fin.write("#ConfDefault:1"); fin.newLine();fin.newLine();
            fin.write("unbindall"); fin.newLine();fin.newLine();

            for (int i=0; i<boxContent.length; i++){
                if (boxContent[i].endsWith("Keys")||boxContent[i].endsWith("Axis")) fin.newLine();
                fin.write(boxContent[i]); //write actual conf
                fin.newLine();
            }
            fin.newLine();
            
            for (int i=2; i<=5; i++){
                keyConversion.setDefaultKeys();
                boxContent = keyConversion.convertToArray();
                boxContent[0]="#Configuration "+i;
                for (int j=0; j<boxContent.length; j++){
                    boxContent[j]="#"+boxContent[j];
                    if (boxContent[j].endsWith("Keys")||boxContent[j].endsWith("Axis")) fin.newLine();
                    fin.write(boxContent[j]); fin.newLine();
                }
                fin.newLine();
            }

            fin.close();

            ReadConf('1'); //Just to back to previous conf (resetted by "keyConversion.setDefaultKeys()")

            return;

        } catch (IOException ex) {
            dialogs.errorDialog("Problem writting key_config.txt.", "Error");
        }
    }

    static boolean fileVersionCheck(String dir) {

        String read, version = null;
        BufferedReader fin;

        try {
            fin = new BufferedReader(new FileReader(dir + "key_config.txt"));
            read = fin.readLine();
            fin.close(); // Not necessary read more
            if (read==null){ //seems the file got corrupted...
                dialogs.errorDialog("Seems the key file got corrupted. A new file will be generated."
                    , "Error");
                keyConversion.setDefaultKeys(); writeCleanFile(dir); return true;
            }
            String[] fVersion = read.split("#Generated with Oni Key Editor v");
            try{
            version = fVersion[1];
             } catch (ArrayIndexOutOfBoundsException e) {
                 return false;
             }

        } catch (FileNotFoundException e) {
            dialogs.errorDialog("File key_config.txt not found. A new file will be created."
                    , "Error");
            keyConversion.setDefaultKeys(); writeCleanFile(dir); return true;
        } catch (IOException e) {
            dialogs.errorDialog("I/O error (key_config.txt) (modified file?)"
                    , "Error");
        }
        System.out.println(version);
        if (version.equals("1.0")) return true;
        else return false;
     
    }

    static void restoreBackup(String dir){

        File keyConfBack = new File(dir+"key_config.txt.bak");
        File keyConf = new File(dir+"key_config.txt");

        if (!keyConfBack.exists()) { //file doesn't exist
            dialogs.errorDialog("No backup found.", "Backup not found");
            return;
        }
        if (!keyConfBack.canWrite()) keyConfBack.setWritable(true); //Set the file writeable

        if(keyConf.exists() && keyConf.canWrite()) keyConf.delete();

        boolean success = copy(keyConfBack, keyConf);

      if (!success) dialogs.errorDialog("Failed restoring Backup.", "Failed");
      else {
            main.setConfDefault('0'); //0, until its read from the file
            readKeyFile(dir);
            if (main.getConfDefault()=='0') writeCleanFile(dir); //if the backup isn't from v1.0 let's convert it
            main.setupConfNames(); //Setup the configuration names read from the file
            dialogs.infDialog("Backup Restored.", "Restored");
      }

    }
    
    static void createBackup(String dir){

        File keyConfBack = new File(dir+"key_config.txt.bak");
        File keyConf = new File(dir+"key_config.txt");

        if (!keyConf.canWrite()) keyConf.setWritable(true); //Set the file writeable
        
        if(keyConfBack.exists() && keyConfBack.canWrite()) keyConfBack.delete();

        boolean success = copy(keyConf, keyConfBack);

      if (!success) dialogs.errorDialog("Failed creating the Backup.", "Failed");
          
      else dialogs.infDialog("Backup created.", "Success");

    }
    
   
    static boolean copy(File originalFile, File newFile) {

        FileReader in;

        try {
            in = new FileReader(originalFile);
            FileWriter out;
            out = new FileWriter(newFile);

            int c;

            while ((c = in.read()) != -1) {
                out.write(c);
            }

            in.close();
            out.close();

        } catch (IOException ex) {
            return false;
        }
        return true;

}

    static void changeIni(){
    JFileChooser od = new JFileChooser();

        od.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        int returnVal = od.showOpenDialog(main.getWindow());
        if (returnVal == JFileChooser.APPROVE_OPTION) {

            File file = od.getSelectedFile();
            main.setOniFolder(file.getAbsolutePath()+System.getProperty("file.separator"));
            createIni();

            if (inputOutput.fileVersionCheck(main.getOniFolder()) == false)
                inputOutput.anotherFile(main.getOniFolder());
            
            checkAeExists();
            main.setConfDefault('0'); //0, until its read from the file
            inputOutput.readKeyFile(main.getOniFolder());
            main.setupConfNames(); //Setup the configuration names read from the file
        }
}

    static void createIni(){
    try {
                BufferedWriter fout = new BufferedWriter(new FileWriter("oke.ini"));

                fout.write("[OniKeyEditor]"); fout.newLine();
                fout.write("Version="+main.getVersion());fout.newLine();fout.newLine();
                fout.write("[OniDefault]"); fout.newLine();
                fout.write("Folder=" + main.getOniFolder());

                fout.close();


            } catch (IOException e) { dialogs.errorDialog("i/o error (oke.ini)", "Error"); }
    }

    static void readSettings(){
        String read, version;
        BufferedReader fin;
        try {
            fin = new BufferedReader(new FileReader("oke.ini"));

            fin.readLine();
            read=fin.readLine();
            String[] auxSplit = read.split("Version=");
            version=auxSplit[1];
            fin.readLine();fin.readLine();
            read=fin.readLine();
            auxSplit = read.split("Folder=");
            main.setOniFolder(auxSplit[1]);
            
            if (!version.equals(main.getVersion())){
                File oke = new File("oke.ini");
                oke.delete();
                askTheUserForFolder();
            }


            fin.close(); 
        } catch (FileNotFoundException ex) {
            askTheUserForFolder();
        } catch (IOException ex) { dialogs.errorDialog("i/o error (oke.ini)", "Error"); }

}

    static void askTheUserForFolder(){

        dialogs.infDialog("The oni folder is not set! Please select your oni folder.",
                "Oni folder not found");

		JFileChooser od = new JFileChooser();

		od.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

		int opt = od.showOpenDialog(main.getWindow());

		if (opt == JFileChooser.APPROVE_OPTION) {

			File file = od.getSelectedFile();
                        main.setOniFolder(file.getAbsolutePath()+System.getProperty("file.separator"));
                        inputOutput.createIni();

                        File keyConf = new File(main.getOniFolder() + "key_config.txt");

                        if (!keyConf.exists()){
                            keyConversion.setDefaultKeys();
                            writeCleanFile(main.getOniFolder());

                            int optHand = dialogs.customDialog("Are you right handed or left handed?",
                            "Choose an option", "Right Handed", "Left Handed");

                            if (optHand == 1){ //Code to handle left hand
                            keyConversion.LeftHand();
                             inputOutput.writeKeyFile(main.getOniFolder());
                            }
                        
                            else keyConversion.DefaultHand(); //Code to handle right hand
                          }
                        
                        }
                else{
                    dialogs.errorDialog(
                    "Oni folder not set. The program can't continue.",
                    "Oni folder not found");
                    System.exit(0);
                }


    }

    static void setOniFolderFC(){

    int opt = dialogs.yesNoDialog("The current oni Folder is:\n"+
            main.getOniFolder()+"\nDo you want to change?", "Change the oni folder?");

    if (opt==0) inputOutput.changeIni();
    else return; //do nothing


}

    static void anotherFile(String dir) {

         File keyConf = new File(dir + "key_config.txt");

            File keyConfBack = new File(dir + "key_config_orig.bak");

            if (keyConfBack.exists() && keyConfBack.canWrite()) keyConfBack.delete();

            boolean success = copy(keyConf, keyConfBack);

            if (!success) dialogs.errorDialog("Failed creating the Backup of original key file.", "Failed");
        
    }

    static void checkAeExists(){
        File AeFolder = new File(main.getAEFolder());

        if(AeFolder.exists()) main.jMenuAeConf.setEnabled(true);
        else main.jMenuAeConf.setEnabled(false);
    }

      static String[] ReadBeforeConf(char confNumber){ //reads the key bindings of specific confs and returns the bufferBefore with it

             String dir=main.getCurrentDir();
             BufferedReader fin=null;
             String read="";
             String[] buffer=null;

             //confNumber--;

            try { fin = new BufferedReader(new FileReader(dir + "key_config.txt")); } catch (FileNotFoundException ex) {}

            while (read!=null){ //while don't reach the end
                
            try {
                read = fin.readLine();
                if (read == null) System.out.println("reached the end");

                if (read.startsWith("#Configuration 1")
                    || read.startsWith("##Configuration 1")) {
                    
                    while (read != null && !read.startsWith("#Configuration "+confNumber)
                            && !read.startsWith("##Configuration "+confNumber)) {

                        buffer=main.addToStringArray(buffer, read);

                        read = fin.readLine();
                    }
                    fin.close();
                    return buffer;
                }
            } catch (IOException ex) {
                Logger.getLogger(inputOutput.class.getName()).log(Level.SEVERE, null, ex);
            }
            }
        try {fin.close();} catch (IOException ex) {}
             return null;
      }

      static String[] ReadAfterConf(char confNumber){ //reads the key bindings of specific confs and returns the bufferBefore with it

             String dir=main.getCurrentDir();
             BufferedReader fin=null;
             String read="";
             String[] buffer=null;

             confNumber++; //for find the next conf and start reading from there

            try { fin = new BufferedReader(new FileReader(dir + "key_config.txt")); } catch (FileNotFoundException ex) {}

            while (read!=null){ //while don't reach the end

            try {
                read = fin.readLine();
                if (read == null) System.out.println("reached the end");

                if (read==null || read.startsWith("#Configuration "+confNumber)
                    || read.startsWith("##Configuration "+confNumber)) {

                    while (read != null){

                        buffer=main.addToStringArray(buffer, read);

                        read = fin.readLine();
                    }
                            fin.close();
                            return buffer;
                }
            } catch (IOException ex) {
                Logger.getLogger(inputOutput.class.getName()).log(Level.SEVERE, null, ex);
            }
            }
             try {fin.close();} catch (IOException ex) {}
             return null;
      }

      static String Comment(String line){
          if (line.startsWith("bind") || line.startsWith("#Co")
              || line.startsWith("#M") || line.startsWith("#I")
              || line.startsWith("#A") || line.startsWith("#O")
              || line.startsWith("#D")){

              line="#"+line;

              }

          return line;
      }


}